import pygame,sys,os,spritesetc
from pygame.locals import *

##os.environ['SDL_VIDEO_CENTERED'] = '1'
import globs 
from globs import *

import sidestats,worldmapRewind,battlecamp
from heroconfig import *
from mapproc import *
from equip import *
from spritesetc import *

pygame.event.set_blocked(MOUSEMOTION)
pygame.mouse.set_visible(False)
pygame.display.set_caption('Of Cabbages and Kings')  ############


#starting equipment of the player... these better be in your inventory
globs.Player  = Hero(Norm(),Cloth(),Handsfeet(),Pitch())#,BasicShield())

#set menu screens
globs.Sides = sidestats.SideBar()
campscreen  = battlecamp.BattleCamp()

#load the initial map
globs.Level   = AMap(globs.Surface,pickle.load(open(os.path.join(worldmapRewind.game_maps[globs.Player.mapset][0],
                     worldmapRewind.game_maps[globs.Player.mapset][1][tuple(globs.Player.mapchoords)]),"rb")),
                     worldmapRewind.game_maps[globs.Player.mapset][1][tuple(globs.Player.mapchoords)])

#necessary map initialization (compile into one function if any more are added)
globs.Level.getmask()
globs.Level.set_hazards()
globs.Level.map_specials() 
globs.Level.spawn()


state = "GAME" #first state here... this will not start as "GAME" once menu is added
clock     = pygame.time.Clock()

reattack  = pygame.time.Clock() #timer to stop constant attack button spamming
attackyet = reattack.tick()
howboutnow= 300

def game():
        global state, howboutnow
        if not globs.Player.dead:
                #if the player is busy with a basic attack the basic direction input loop is skipped
                if globs.isbusy == False:
                    #basic direction inputs here
                    for event in pygame.event.get():
                        if event.type == QUIT:
                            pygame.quit();sys.exit()
                        if event.type == KEYDOWN:
                            if event.key == K_RIGHT:
                                if globs.Player.direction != "right":
                                    globs.Player.direction = "right"
                                    globs.Player.make_image()
                                globs.Player.walk = True
                            if event.key == K_LEFT:
                                if globs.Player.direction != "left":
                                    globs.Player.direction = "left"
                                    globs.Player.make_image()
                                globs.Player.walk = True
                            if event.key == K_UP:
                                if globs.Player.direction != "back":
                                    globs.Player.direction = "back"
                                    globs.Player.make_image()
                                globs.Player.walk = True
                            if event.key == K_DOWN:
                                if globs.Player.direction != "front":
                                    globs.Player.direction = "front"
                                    globs.Player.make_image()
                                globs.Player.walk = True

                            #normal attack button    
                            if event.key == K_SPACE:
                                attackyet = reattack.tick() #attack button will only attack after 300 ms have elapsed
                                if attackyet > howboutnow:   
                                    if globs.Player.attack != True:  
                                        globs.Player.walk   = False
                                        globs.Player.weapon.damage_on = True ## Don't think this is needed anymore
                                        globs.Player.attack = True
                                        globs.isbusy        = True
                                        globs.Player.make_image()
                                        howboutnow = 300
                                else:
                                    howboutnow -= attackyet

                            if event.key == K_s:
                                #go to battlecamp menu
                                globs.Player.olddirection = globs.Player.direction
        ##                        globs.Player.direction    = "front"
        ##                        globs.Player.walk = False
        ##                        globs.Player.make_image()
                                state = "CAMP"

                            if event.key == K_ESCAPE:
                                #make this give a prompt in the future
                                pygame.quit(); sys.exit()
                                
                                     
                                    
                                    

                        #this deals with direction button presses overlapping.
                        #takes a lot of extra space but seems to work cleanly
                        if event.type == KEYUP:
                            keys = pygame.key.get_pressed()
                            if event.key == K_RIGHT:
                                if keys[K_LEFT]:
                                    if globs.Player.direction != "left":
                                        globs.Player.direction = "left"
                                        globs.Player.make_image()
                                elif keys[K_UP]:
                                    if globs.Player.direction != "back":
                                        globs.Player.direction = "back"
                                        globs.Player.make_image()
                                elif keys[K_DOWN]:
                                    if globs.Player.direction != "front":
                                        globs.Player.direction = "front"
                                        globs.Player.make_image()
                                else:
                                    globs.Player.walk = False
                            if event.key == K_LEFT:
                                if keys[K_RIGHT]:
                                    if globs.Player.direction != "right":
                                        globs.Player.direction = "right"
                                        globs.Player.make_image()
                                elif keys[K_UP]:
                                    if globs.Player.direction != "back":
                                        globs.Player.direction = "back"
                                        globs.Player.make_image()
                                elif keys[K_DOWN]:
                                    if globs.Player.direction != "front":
                                        globs.Player.direction = "front"
                                        globs.Player.make_image()
                                else:
                                    globs.Player.walk = False
                            if event.key == K_UP:
                                if keys[K_RIGHT]:
                                    if globs.Player.direction != "right":
                                        globs.Player.direction = "right"
                                        globs.Player.make_image()
                                elif keys[K_LEFT]:
                                    if globs.Player.direction != "left":
                                        globs.Player.direction = "left"
                                        globs.Player.make_image()
                                elif keys[K_DOWN]:
                                    if globs.Player.direction != "front":
                                        globs.Player.direction = "front"
                                        globs.Player.make_image()
                                else:
                                    globs.Player.walk = False
                            if event.key == K_DOWN:
                                if keys[K_RIGHT]:
                                    if globs.Player.direction != "right":
                                        globs.Player.direction = "right"
                                        globs.Player.make_image()
                                elif keys[K_UP]:
                                    if globs.Player.direction != "back":
                                        globs.Player.direction = "back"
                                        globs.Player.make_image()
                                elif keys[K_LEFT]:
                                    if globs.Player.direction != "left":
                                        globs.Player.direction = "left"
                                        globs.Player.make_image()
                                else:
                                    globs.Player.walk = False

                else: #this loop runs if the attack has finished and then resets state to not busy
                    if globs.Player.attack == False:
                        globs.Player.make_image()
                        keys = pygame.key.get_pressed()
                        if keys[K_LEFT]:
                            if globs.Player.direction != "left":
                                globs.Player.direction = "left"
                                globs.Player.make_image()
                                globs.Player.walk = True
                            else: globs.Player.walk = True 
                        elif keys[K_UP]:
                            if globs.Player.direction != "back":
                                globs.Player.direction = "back"
                                globs.Player.make_image()
                                globs.Player.walk = True
                            else: globs.Player.walk = True
                        elif keys[K_DOWN]:
                            if globs.Player.direction != "front":
                                globs.Player.direction = "front"
                                globs.Player.make_image()
                                globs.Player.walk = True
                            else: globs.Player.walk = True
                        elif keys[K_RIGHT]:
                            if globs.Player.direction != "right":
                                globs.Player.direction = "right"
                                globs.Player.make_image()
                                globs.Player.walk = True
                            else: globs.Player.walk = True

                        globs.isbusy = False #back to the normal event loop

        else:
                for event in pygame.event.get():
                        if event.type == QUIT:
                            pygame.quit();sys.exit()
                        if event.type == KEYDOWN:
                                if event.key == K_ESCAPE:
                                        #make this give a prompt in the future
                                        pygame.quit(); sys.exit()
                                        


        #this is where the order layers are drawn is declared
        globs.Level.loadmap()    
        if globs.Player.deathframe >= 5: #monsters shouldn't run under the gravestone
            globs.Player.draw()
        for key in globs.Level.objects:
                if key != "projectiles":
                        for item in globs.Level.objects[key]:
                            item.update()
        globs.Player.update()
        if globs.Player.deathframe < 5:
            globs.Player.draw()
        globs.Level.paintfore()
        for item in globs.Level.objects["projectiles"]:
            item.update() 
        globs.Sides.update()
        if globs.Player.head.visionPnlty == True:
                globs.Player.vision_impairment()

        globs.Level.map_update() #does the map need to add any events (experimental)
        
##        if globs.Player.dead == True and globs.Player.deathframe >= 6: pass
##            state = "Game Over"
            
def camp():
    #control flow for the battle camp screen (gets a little messy but some menus have three or more layers so....)
    global state

    def reset():
        global state
        globs.Surface.blit(campscreen.game_state,(0,0))
        campscreen.mainmen  = True
        campscreen.scrolled = False
        campscreen.ready    = False
        campscreen.equipmen = False
        campscreen.specmen  = False
        campscreen.itemmen  = False
        campscreen.specific = False
        campscreen.gearscrolled = False
        campscreen.mainchoords = 0
        campscreen.subchoords  = [0,0]
        campscreen.specifchoords = [0,0]
        globs.Player.direction = globs.Player.olddirection
        globs.Player.make_image()
        state = "GAME"
        
    if campscreen.ready    == False:
        campscreen.setitup()
    if campscreen.scrolled == False:
        campscreen.scroll()

    if campscreen.scrolled == True:
            for event in pygame.event.get():
                        if event.type == QUIT:
                            pygame.quit();sys.exit()
                        if event.type == KEYDOWN:
                            if event.key == K_s:
                                    reset()
                                    
                            if event.key == K_DOWN:
                                    if campscreen.mainmen:
                                            soundfx["chimed"].play()
                                            if campscreen.mainchoords < 3:
                                                    campscreen.mainchoords += 1
                                            else: campscreen.mainchoords = 0
                                    elif campscreen.equipmen and not campscreen.specific:
                                            if campscreen.subchoords[1] == 1: campscreen.subchoords[1] = 0
                                            else: campscreen.subchoords[1] = 1
                                    elif campscreen.equipmen and campscreen.specific:
                                            pass #add if items exceed 8
                            elif event.key == K_UP:
                                    if campscreen.mainmen:
                                            soundfx["chimed"].play()
                                            if campscreen.mainchoords != 0:
                                                    campscreen.mainchoords -= 1
                                            else: campscreen.mainchoords = 3
                                    elif campscreen.equipmen and not campscreen.specific:
                                            if campscreen.subchoords[1] == 1: campscreen.subchoords[1] = 0
                                            else: campscreen.subchoords[1] = 1
                                    elif campscreen.equipmen and campscreen.specific:
                                            pass #add if items exceed 8
                                            
                            elif event.key == K_RIGHT:
                                    if campscreen.equipmen and not campscreen.specific:
                                            if campscreen.subchoords[0] < 4:
                                                    campscreen.subchoords[0] += 1
                                            else: campscreen.subchoords[0]    = 0
                                    elif campscreen.equipmen and campscreen.specific:
                                            if campscreen.specifchoords[0] == 7:
                                                    campscreen.specif[0] = 0
                                            else:
                                                if campscreen.specifchoords[1] == 0:
                                                    if len(campscreen.gear_dict)-1 > campscreen.specifchoords[0]: campscreen.specifchoords[0] += 1
                                                    else: campscreen.specifchoords[0] = 0
                                                else:
                                                    if len(campscreen.gear_dict)-9 > campscreen.specifchoords[0]: campscreen.specifchoords[0] += 1
                                                    else: campscreen.specifchoords[0] = 0
                                                                                                
                            elif event.key == K_LEFT:
                                    if campscreen.equipmen and not campscreen.specific:
                                            if campscreen.subchoords[0] != 0:
                                                    campscreen.subchoords[0] -= 1
                                            else: campscreen.subchoords[0]    = 4
                                    elif campscreen.equipmen and campscreen.specific:
                                            if campscreen.specifchoords[0] != 0:
                                                    campscreen.specifchoords[0] -= 1
                                            else:
                                                if campscreen.specifchoords[1] == 0:
                                                        if len(campscreen.gear_dict) <= 8: campscreen.specifchoords[0] = len(campscreen.gear_dict)-1
                                                        else: campscreen.specifchoords[0] = 7
                                                else:
                                                        campscreen.specifchoords = len(campscreen.gear_dict)-8
                                                                                           
                            elif event.key == K_RETURN:
                                    if campscreen.mainmen:
                                            if campscreen.mainchoords == 0:
                                                    campscreen.equipmen = True
                                                    campscreen.mainmen  = False
                                    elif campscreen.equipmen and not campscreen.specific:
                                            if campscreen.subchoords[1] == 1:
                                                    campscreen.equipmen = False
                                                    campscreen.mainmen  = True
                                                    campscreen.subchoords = [0,0]
                                            else:
                                                    campscreen.specific = True
                                    elif campscreen.equipmen and campscreen.specific:
                                            if campscreen.subchoords[0]  == 0:
                                                globs.Player.equipped["body"] = campscreen.gear_dict[(campscreen.specifchoords[0],campscreen.specifchoords[1])]
                                            elif campscreen.subchoords[0] == 1:
                                                globs.Player.equipped["head"] = campscreen.gear_dict[(campscreen.specifchoords[0],campscreen.specifchoords[1])]
                                            elif campscreen.subchoords[0] == 2:
                                                globs.Player.equipped["armleg"] = campscreen.gear_dict[(campscreen.specifchoords[0],campscreen.specifchoords[1])]
                                            elif campscreen.subchoords[0] == 3:
                                                globs.Player.equipped["weapon"] = campscreen.gear_dict[(campscreen.specifchoords[0],campscreen.specifchoords[1])]
                                                globs.Sides.update_inmenu()
                                            elif campscreen.subchoords[0] == 4:
                                                globs.Player.equipped["shield"] = campscreen.gear_dict[(campscreen.specifchoords[0],campscreen.specifchoords[1])]

                                            globs.Player.head   = globs.Player.equipped["head"]
                                            globs.Player.body   = globs.Player.equipped["body"]
                                            globs.Player.weapon = globs.Player.equipped["weapon"]
                                            globs.Player.armleg = globs.Player.equipped["armleg"]
                                            globs.Player.shield = globs.Player.equipped["shield"]

                                            globs.Player.make_image()
                                            globs.Player.updatestats()
                                            
                                            campscreen.setitup()
                                            globs.Surface.fill((0,0,0),(200,0,1000,700))
                                            globs.Surface.blit(campscreen.page,(200,0))

                                            campscreen.specific      = False
                                            campscreen.gearscrolled  = False
                                            campscreen.specifchoords = [0,0]
                           
                            elif event.key == K_x:
                                    if not campscreen.mainmen:
                                            campscreen.mainmen  = True
                                            campscreen.equipmen = False
                                            campscreen.specmen  = False
                                            campscreen.itemmen  = False
                                            campscreen.specific = False
                                            campscreen.gearscrolled = False
                                            campscreen.subchoords    = [0,0]
                                            campscreen.specifchoords = [0,0]
                                    else:   reset()
                                       
    campscreen.update()
    
    
            
    

            





def main():
    i = 0 #remove later, used for fps print statement slowdown
    while True:
        if state == "MENU": pass
            
        elif state == "GAME":
            game()
        elif state == "CAMP":
            globs.Player.direction    = "front"
            globs.Player.walk = False
            globs.Player.make_image()
            camp()
        elif state == "Game Over":
##            print("and now you're dead")
            #temporary way to end game gracefully for the moment after dieing
            while pygame.event.wait().type != QUIT: pass
            else: pygame.quit();sys.exit()
            
            #gameOverMenu()

        pygame.display.update()
        clock.tick(65)

##        if i == 50:
##            print(clock.get_fps())
##            i = 0
##        i += 1
            

##########
if __name__ == "__main__":
    pygame.init()
    main()
